aboutsummaryrefslogtreecommitdiffstats
path: root/package/base-files/files/lib/upgrade/fwtool.sh
diff options
context:
space:
mode:
Diffstat (limited to 'package/base-files/files/lib/upgrade/fwtool.sh')
-rw-r--r--package/base-files/files/lib/upgrade/fwtool.sh25
1 files changed, 25 insertions, 0 deletions
diff --git a/package/base-files/files/lib/upgrade/fwtool.sh b/package/base-files/files/lib/upgrade/fwtool.sh
index aa2ac79d13..3f28fccd90 100644
--- a/package/base-files/files/lib/upgrade/fwtool.sh
+++ b/package/base-files/files/lib/upgrade/fwtool.sh
@@ -1,3 +1,28 @@
+fwtool_check_signature() {
+ [ $# -gt 1 ] && return 1
+
+ [ ! -x /usr/bin/ucert ] && {
+ if [ "$REQUIRE_IMAGE_SIGNATURE" = 1 ]; then
+ return 1
+ else
+ return 0
+ fi
+ }
+
+ if ! fwtool -q -t -s /tmp/sysupgrade.ucert "$1"; then
+ echo "Image signature not found"
+ [ "$REQUIRE_IMAGE_SIGNATURE" = 1 -a "$FORCE" != 1 ] && {
+ echo "Use sysupgrade -F to override this check when downgrading or flashing to vendor firmware"
+ }
+ [ "$REQUIRE_IMAGE_SIGNATURE" = 1 ] && return 1
+ return 0
+ fi
+
+ ucert -V -m "$1" -c "/tmp/sysupgrade.ucert" -P /etc/opkg/keys
+
+ return $?
+}
+
fwtool_check_image() {
[ $# -gt 1 ] && return 1